#ifndef DRAWAREA_H
#define DRAWAREA_H

#include <QWidget>
#include <QPaintEvent>
#include <vector>
#include "R2Graph/R2Graph.h"

class DrawArea : public QWidget
{
    Q_OBJECT
public:
    double xmin, xmax;
    double ymin, ymax;
    double xcoeff, ycoeff;

    std::vector<R2Point> points;

    R2Point bis[3];
    R2Point center;
    double radius;
    bool triangleComputed;

    QPointF map(const R2Point& t) const {
        return QPointF(
            (t.x - xmin)*xcoeff,
            (ymax - t.y)*ycoeff
        );
    }

    R2Point invMap(const QPointF& p) const {
        return R2Point(
           xmin + p.x()/xcoeff,
           ymax - p.y()/ycoeff
        );
    }

    void drawCoordGrid(QPainter* p);
    void drawTriangle(QPainter* p);
    void clear();
    void onDraw();

    explicit DrawArea(QWidget *parent = 0);
    void paintEvent(QPaintEvent *);
    void mousePressEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *e);
signals:

public slots:
};

#endif // DRAWAREA_H
